
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "sif.h"

static int	PowerOf3(index)
int		index;
{
	int	powerof3=1;

	while (--index>=0) powerof3*=3; return powerof3;
}

static Cell	**cell;

static void	Gasket(level,x0,y0)
int		level,x0,y0;
{
	if (level)
{
	int	gap=PowerOf3(--level),
		x1=x0+gap,x2=x1+gap,y1=y0+gap,y2=y1+gap;

	Gasket(level,x0,y0); Gasket(level,x1,y0); Gasket(level,x2,y0);
	Gasket(level,x0,y1);			  Gasket(level,x2,y1);
	Gasket(level,x0,y2); Gasket(level,x1,y2); Gasket(level,x2,y2);
}
	else
	    cell[y0][x0]=1;
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	level,Nxy,x,y;
	char	*nm="no memory.\n";

	if (argc!=3) {
	    fputs("usage : gasket2 level TIFF\n",stderr); exit(1);
	}
	if ((level=atoi(argv[1]))<=0) {
	    fputs("bad level.\n",stderr); exit(1);
	}
	Nxy=PowerOf3(level);

	if ((cell=(Cell **)malloc(Nxy*sizeof(*cell)))==NULL) {
	    fputs(nm,stderr); exit(1);
	}
	for (y=0; y<Nxy; y++) {
	    if ((cell[y]=(Cell *)malloc(Nxy*sizeof(**cell)))==NULL) {
		fputs(nm,stderr); exit(1);
	    }
	    for (x=0; x<Nxy; x++) cell[y][x]=0;
	}

	Gasket(level,0,0);

	StoreImageFile(argv[2],Nxy,Nxy,1,cell,NULL);

	return 0;
}
