
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "sif.h"

static int	PowerOf3(index)
int		index;
{
	int	powerof3=1;

	while (--index>=0) powerof3*=3; return powerof3;
}

static Cell	***cell;

static void	Gasket(level,x0,y0,z0)
int		level,x0,y0,z0;
{
	if (level)
{
	int	gap=PowerOf3(--level),
		x1=x0+gap,x2=x1+gap,y1=y0+gap,y2=y1+gap,z1=z0+gap,z2=z1+gap;

	Gasket(level,x0,y0,z0); Gasket(level,x1,y0,z0); Gasket(level,x2,y0,z0);
	Gasket(level,x0,y1,z0);				Gasket(level,x2,y1,z0);
	Gasket(level,x0,y2,z0); Gasket(level,x1,y2,z0); Gasket(level,x2,y2,z0);
	Gasket(level,x0,y0,z1);				Gasket(level,x2,y0,z1);
	Gasket(level,x0,y2,z1);				Gasket(level,x2,y2,z1);
	Gasket(level,x0,y0,z2); Gasket(level,x1,y0,z2); Gasket(level,x2,y0,z2);
	Gasket(level,x0,y1,z2);				Gasket(level,x2,y1,z2);
	Gasket(level,x0,y2,z2); Gasket(level,x1,y2,z2); Gasket(level,x2,y2,z2);
}
	else
	    cell[z0][y0][x0]=1;
}

#define STR_LEN	256

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	level,Nxyz,x,y,z,len;
	char	format[STR_LEN],path[STR_LEN],*nm="no memory.\n";

	if (argc!=3) {
	    fputs("usage : gasket3 level directory\n",stderr); exit(1);
	}
	if ((level=atoi(argv[1]))<=0) {
	    fputs("bad level.\n",stderr); exit(1);
	}
	Nxyz=PowerOf3(level);

	if ((cell=(Cell ***)malloc(Nxyz*sizeof(*cell)))==NULL) {
	    fputs(nm,stderr); exit(1);
	}
	for (z=0; z<Nxyz; z++) {
	    if ((cell[z]=(Cell **)malloc(Nxyz*sizeof(**cell)))==NULL) {
		fputs(nm,stderr); exit(1);
	    }
	    for (y=0; y<Nxyz; y++) {
		if ((cell[z][y]=(Cell *)malloc(Nxyz*sizeof(***cell)))==NULL) {
		    fputs(nm,stderr); exit(1);
		}
		for (x=0; x<Nxyz; x++) cell[z][y][x]=0;
	    }
	}

	Gasket(level,0,0,0);

	if (Nxyz==1)
	    len=1;
	else {
	    len=0; for (z=Nxyz-1; z>0; z/=10) len++;
	}
	sprintf(format,"%s/%%0%dd.tif",argv[2],len);

	for (z=0; z<Nxyz; z++) {
	    sprintf(path,format,z);
	    StoreImageFile(path,Nxyz,Nxyz,1,cell[z],NULL);
	}
	return 0;
}
